2 # kbuild: Generic definitions
9 space := $(empty) $(empty)
13 # Name of target with a '.' as filename prefix. foo/bar.o => foo/.bar.o
14 dot-target = $(dir $@).$(notdir $@)
17 # The temporary file to save gcc -MD generated dependencies must not
19 depfile = $(subst $(comma),_,$(dot-target).d)
22 # filename of target with directory and extension stripped
23 basetarget = $(basename $(notdir $@))
26 # filename of first prerequisite with directory and extension stripped
27 baseprereq = $(basename $(notdir $<))
30 # Escape single quote for use in echo statements
31 escsq = $(subst $(squote),'\$(squote)',$1)
34 # Easy method for doing a status message
38 kecho := $($(quiet)kecho)
41 # filechk is used to check if the content of a generated file is updated.
43 # define filechk_sample
46 # version.h : Makefile
47 # $(call filechk,sample)
48 # The rule defined shall write to stdout the content of the new file.
49 # The existing file will be compared with the new one.
50 # - If no file exist it is created
51 # - If the content differ the new file is used
52 # - If they are equal no change, and no timestamp update
53 # - stdin is piped in from the first prerequisite ($<) so one has
54 # to specify a valid file as first prerequisite (often the kbuild file)
59 $(filechk_$(1)) < $< > $@.tmp; \
60 if [ -r $@ ] && cmp -s $@ $@.tmp; then \
69 # gcc support functions
70 # See documentation in Documentation/kbuild/makefiles.txt
73 # Usage: CROSS_COMPILE := $(call cc-cross-prefix, m68k-linux-gnu- m68k-linux-)
74 # Return first prefix where a prefix$(CC) is found in PATH.
75 # If no $(CC) found in PATH with listed prefixes return nothing
77 $(word 1, $(foreach c,$(1), \
79 if (which $(strip $(c))$(CC)) > /dev/null 2>&1 ; then \
83 # output directory for tests below
84 TMPOUT := $(if $(KBUILD_EXTMOD),$(firstword $(KBUILD_EXTMOD))/)
87 # Usage: option = $(call try-run, $(CC)...-o "$$TMP",option-ok,otherwise)
88 # Exit code chooses option. "$$TMP" is can be used as temporary file and
89 # is automatically cleaned up.
90 # modifed for U-Boot: prevent cc-option from leaving .*.su files
91 try-run = $(shell set -e; \
92 TMP="$(TMPOUT).$$$$.tmp"; \
93 TMPO="$(TMPOUT).$$$$.o"; \
94 TMPSU="$(TMPOUT).$$$$.su"; \
95 if ($(1)) >/dev/null 2>&1; \
99 rm -f "$$TMP" "$$TMPO" "$$TMPSU")
102 # Usage: cflags-y += $(call as-option,-Wa$(comma)-isa=foo,)
104 as-option = $(call try-run,\
105 $(CC) $(KBUILD_CFLAGS) $(1) -c -x assembler /dev/null -o "$$TMP",$(1),$(2))
108 # Usage: cflags-y += $(call as-instr,instr,option1,option2)
110 as-instr = $(call try-run,\
111 printf "%b\n" "$(1)" | $(CC) $(KBUILD_AFLAGS) -c -x assembler -o "$$TMP" -,$(2),$(3))
114 # Usage: cflags-y += $(call cc-option,-march=winchip-c6,-march=i586)
116 cc-option = $(call try-run,\
117 $(CC) -Werror $(KBUILD_CPPFLAGS) $(KBUILD_CFLAGS) $(1) -c -x c /dev/null -o "$$TMP",$(1),$(2))
120 # Usage: flag := $(call cc-option-yn,-march=winchip-c6)
121 cc-option-yn = $(call try-run,\
122 $(CC) -Werror $(KBUILD_CPPFLAGS) $(KBUILD_CFLAGS) $(1) -c -x c /dev/null -o "$$TMP",y,n)
125 # Prefix align with either -falign or -malign
126 cc-option-align = $(subst -functions=0,,\
127 $(call cc-option,-falign-functions=0,-malign-functions=0))
130 # Usage: cflags-y += $(call cc-disable-warning,unused-but-set-variable)
131 cc-disable-warning = $(call try-run,\
132 $(CC) $(KBUILD_CPPFLAGS) $(KBUILD_CFLAGS) -W$(strip $(1)) -c -x c /dev/null -o "$$TMP",-Wno-$(strip $(1)))
135 # Expands to either gcc or clang
136 cc-name = $(shell $(CC) -v 2>&1 | grep -q "clang version" && echo clang || echo gcc)
139 cc-version = $(shell $(CONFIG_SHELL) $(srctree)/scripts/gcc-version.sh $(CC))
142 cc-fullversion = $(shell $(CONFIG_SHELL) \
143 $(srctree)/scripts/gcc-version.sh -p $(CC))
146 # Usage: EXTRA_CFLAGS += $(call cc-ifversion, -lt, 0402, -O1)
147 cc-ifversion = $(shell [ $(cc-version) $(1) $(2) ] && echo $(3) || echo $(4))
150 binutils-version = $(shell $(CONFIG_SHELL) $(srctree)/scripts/binutils-version.sh $(AS))
151 dtc-version = $(shell $(CONFIG_SHELL) $(srctree)/scripts/dtc-version.sh $(DTC))
154 # Usage: ldflags += $(call cc-ldoption, -Wl$(comma)--hash-style=both)
155 cc-ldoption = $(call try-run,\
156 $(CC) $(1) -nostdlib -x c /dev/null -o "$$TMP",$(1),$(2))
159 # Usage: LDFLAGS += $(call ld-option, -X)
160 ld-option = $(call try-run,\
161 $(CC) -x c /dev/null -c -o "$$TMPO" ; $(LD) $(1) "$$TMPO" -o "$$TMP",$(1),$(2))
164 # Usage: KBUILD_ARFLAGS := $(call ar-option,D)
165 # Important: no spaces around options
166 ar-option = $(call try-run, $(AR) rc$(1) "$$TMP",$(1),$(2))
169 # Note this is mainly for HJ Lu's 3 number binutil versions
170 ld-version = $(shell $(LD) --version | $(srctree)/scripts/ld-version.sh)
173 # Usage: $(call ld-ifversion, -ge, 22252, y)
174 ld-ifversion = $(shell [ $(ld-version) $(1) $(2) ] && echo $(3) || echo $(4))
179 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.build obj=
181 # $(Q)$(MAKE) $(build)=dir
182 build := -f $(srctree)/scripts/Makefile.build obj
185 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.modbuiltin obj=
187 # $(Q)$(MAKE) $(modbuiltin)=dir
188 modbuiltin := -f $(srctree)/scripts/Makefile.modbuiltin obj
191 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.dtbinst obj=
193 # $(Q)$(MAKE) $(dtbinst)=dir
194 dtbinst := -f $(if $(KBUILD_SRC),$(srctree)/)scripts/Makefile.dtbinst obj
197 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.clean obj=
199 # $(Q)$(MAKE) $(clean)=dir
200 clean := -f $(srctree)/scripts/Makefile.clean obj
203 # Shorthand for $(Q)$(MAKE) -f scripts/Makefile.headersinst obj=
205 # $(Q)$(MAKE) $(hdr-inst)=dir
206 hdr-inst := -f $(srctree)/scripts/Makefile.headersinst obj
208 # Prefix -I with $(srctree) if it is not an absolute path.
209 # skip if -I has no parameter
210 addtree = $(if $(patsubst -I%,%,$(1)), \
211 $(if $(filter-out -I/%,$(1)),$(patsubst -I%,-I$(srctree)/%,$(1))) $(1))
213 # Find all -I options and call addtree
214 flags = $(foreach o,$($(1)),$(if $(filter -I%,$(o)),$(call addtree,$(o)),$(o)))
217 # Short version is used, if $(quiet) equals `quiet_', otherwise full one.
218 echo-cmd = $(if $($(quiet)cmd_$(1)),\
219 echo ' $(call escsq,$($(quiet)cmd_$(1)))$(echo-why)';)
222 cmd = @$(echo-cmd) $(cmd_$(1))
224 # Add $(obj)/ for paths that are not absolute
225 objectify = $(foreach o,$(1),$(if $(filter /%,$(o)),$(o),$(obj)/$(o)))
228 # if_changed - execute command if any prerequisite is newer than
229 # target, or command line has changed
230 # if_changed_dep - as if_changed, but uses fixdep to reveal dependencies
231 # including used config symbols
232 # if_changed_rule - as if_changed but execute rule instead
233 # See Documentation/kbuild/makefiles.txt for more info
235 ifneq ($(KBUILD_NOCMDDEP),1)
236 # Check if both arguments has same arguments. Result is empty string if equal.
237 # User may override this check using make KBUILD_NOCMDDEP=1
238 arg-check = $(strip $(filter-out $(cmd_$(1)), $(cmd_$@)) \
239 $(filter-out $(cmd_$@), $(cmd_$(1))) )
241 arg-check = $(if $(strip $(cmd_$@)),,1)
244 # Replace >$< with >$$< to preserve $ when reloading the .cmd file
246 # Replace >#< with >$(pound)< to avoid starting a comment in the .cmd file
248 # Replace >'< with >'\''< to be able to enclose the whole string in '...'
249 # (needed for the shell)
250 make-cmd = $(call escsq,$(subst $(pound),$$(pound),$(subst $$,$$$$,$(cmd_$(1)))))
252 # Find any prerequisites that is newer than target or that does not exist.
253 # PHONY targets skipped in both cases.
254 any-prereq = $(filter-out $(PHONY),$?) $(filter-out $(PHONY) $(wildcard $^),$^)
256 # Execute command if command has changed or prerequisite(s) are updated.
258 if_changed = $(if $(strip $(any-prereq) $(arg-check)), \
260 $(echo-cmd) $(cmd_$(1)); \
261 printf '%s\n' 'cmd_$@ := $(make-cmd)' > $(dot-target).cmd)
263 # Execute the command and also postprocess generated .d dependencies file.
264 if_changed_dep = $(if $(strip $(any-prereq) $(arg-check) ), \
266 $(echo-cmd) $(cmd_$(1)); \
267 scripts/basic/fixdep $(depfile) $@ '$(make-cmd)' > $(dot-target).tmp;\
269 mv -f $(dot-target).tmp $(dot-target).cmd)
271 # Usage: $(call if_changed_rule,foo)
272 # Will check if $(cmd_foo) or any of the prerequisites changed,
273 # and if so will execute $(rule_foo).
274 if_changed_rule = $(if $(strip $(any-prereq) $(arg-check) ), \
279 # why - tell why a a target got build
280 # enabled by make V=2
281 # Output (listed in the order they are checked):
282 # (1) - due to target is PHONY
283 # (2) - due to target missing
284 # (3) - due to: file1.h file2.h
285 # (4) - due to command line change
286 # (5) - due to missing .cmd file
287 # (6) - due to target not in $(targets)
288 # (1) PHONY targets are always build
289 # (2) No target, so we better build it
290 # (3) Prerequisite is newer than target
291 # (4) The command line stored in the file named dir/.target.cmd
292 # differed from actual command line. This happens when compiler
294 # (5) No dir/.target.cmd file (used to store command line)
295 # (6) No dir/.target.cmd file and target not listed in $(targets)
296 # This is a good hint that there is a bug in the kbuild file
297 ifeq ($(KBUILD_VERBOSE),2)
299 $(if $(filter $@, $(PHONY)),- due to target is PHONY, \
300 $(if $(wildcard $@), \
301 $(if $(strip $(any-prereq)),- due to: $(any-prereq), \
303 $(if $(cmd_$@),- due to command line change, \
304 $(if $(filter $@, $(targets)), \
305 - due to missing .cmd file, \
306 - due to $(notdir $@) not in $$(targets) \
311 - due to target missing \
315 echo-why = $(call escsq, $(strip $(why)))
318 # delete partially updated (i.e. corrupted) files on error
321 ifdef CONFIG_SPL_BUILD
323 ifeq ($(CONFIG_TPL_BUILD),y)